/*
 * Copyright (C) 2006 Jean-Yves Lefort <jylefort@FreeBSD.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _LINUX_JS_DEVGLUE_H
#define _LINUX_JS_DEVGLUE_H

#include <sys/syslimits.h>
#include "linux_js.h"

#define LINUX_JS_DEVGLUE(instance)	((struct linux_js_devglue *) instance)
#define LINUX_JS_DEVGLUE_CLASS(class)	((struct linux_js_devglue_class *) class)

struct linux_js_devglue
{
  struct linux_js	base;
  char			filename[PATH_MAX];
  char			*devname;
  int			fd;
};

struct linux_js_devglue_class
{
  struct linux_js_class	base;

  const char		*devname;

  int			(*attach)	(struct linux_js_devglue *devglue);
  void			(*open)		(struct linux_js_devglue *devglue);
};

void linux_js_devglue_class_init (struct linux_js_devglue_class *class);

#endif /* _LINUX_JS_DEVGLUE_H */
